import { AbortError } from '@libp2p/interface';
import pDefer from 'p-defer';
export class JobRecipient {
    deferred;
    signal;
    where;
    constructor(where, signal) {
        this.signal = signal;
        this.deferred = pDefer();
        this.where = where;
        this.onAbort = this.onAbort.bind(this);
        this.signal?.addEventListener('abort', this.onAbort);
    }
    onAbort() {
        this.deferred.reject(new AbortError());
    }
    cleanup() {
        this.signal?.removeEventListener('abort', this.onAbort);
    }
}
//# sourceMappingURL=recipient.js.map